Imports System
Imports iNTERFACEWARE.Chameleon
Imports PrefixTest

Class ServerEngine
   Inherits PrefixTestEngine

   Public overrides Sub ParseMessage(ByVal flatwire As String, ByVal aTransport As Transport)
      Try

         MyBase.ParseMessage(flatwire, aTransport)

      Catch ex As ChameleonException

         ErrorEvent(ex, "Error parsing message")
         ' TODO - log the message so it can be analyzed later.

      Catch ex As Exception

         ErrorEvent(ex, "General exception")
         ' TODO - log the message so it can be analyzed later.

      End Try

   End Sub
   Public Overrides Sub OnPatientRegisterMessage(ByVal aMessage As PatientRegisterMessage, ByVal aTransport As Transport)

      Try

         Println("PatientRegister message parsed with data:")
         Println("LastName:" + aMessage.Patient(0).LastName().ToString())
         Println("FirstName:" + aMessage.Patient(0).FirstName().ToString())
         Println("Dob:" + aMessage.Patient(0).Dob().ToString())
         Println("BirthOrder:" + aMessage.Patient(0).BirthOrder().ToString())
         Println("SpeciesCode:" + aMessage.Patient(0).SpeciesCode().ToString())
         Println("")

      Catch ex As ChameleonException

         ErrorEvent(ex, "Error in PatientRegister message")
      End Try
   End Sub

   Public Overrides Sub OnDefaultMessage(ByVal aMessage As DefaultMessage, ByVal aTransport As Transport)

      Try

         Println("Default message parsed with data:")
         Println("")

      Catch ex As ChameleonException

         ErrorEvent(ex, "Error in Default message")
      End Try
   End Sub

End Class
